<template>
	<view v-if="detaile">
		<view class="title">{{ detaile.title }}</view>
		<view class="det-sta dflex">
			<view class="sitename" @click="toIndex('')">{{config.CONFIG_PROJECT_TITLE}}</view>
			<view class="time">{{getDateTimeStamp(detaile.time)}}</view>
		</view>
		<view class="content">
			<view :class="'viewMore' + (viewMore?'':' con-vheight')">
				<mp-html :content="detaile.text" :lazy-load="true" @imgtap="choose"></mp-html>
			</view>
			<view class="view-more" @tap="viewMores()" v-if="!viewMore">查看全文</view>
		</view>
		<view class="operate dflex">
			<view class="zan dflex"><image src="../static/images/view.png"></image>{{detaile.browse}}</view>
			<button class="share dflex" hover-class="none" open-type="share"><image src="../static/images/share.png"></image>分享</button>
		</view>
		<view class="box" v-if="contentList && contentList.length > 0">
			<view class="tit dflex">为您推荐</view>
			<view class="rec">
				<navigator :url="'/topic/content/content?id=' + item.id" hover-class="none" class="li dflex" v-for="(item,index) in contentList" :key="index" v-if="index < 3">
					<view class="flex">
						<view class="rec-tit tovers">{{item.title}}</view>
						<view class="dflex">
							<!-- <view class="author ddflex"><image src="../../static/pages/images/zbgw.png" mode="aspectFill"></image>欧衡</view> -->
							<view class="rec-time">{{item.createDate}}</view>
						</view>
					</view>
					<image :src="item.pic" mode="aspectFill" class="rec-img"></image>
				</navigator>
			</view>
		</view>
	</view>
</template>

<script>
const app = getApp();
const req = require('../../utils/request.js');
const api = require('../../utils/api.js');
const util = require('../../utils/util.js');
import mpHtml from "../../components/mp-html/components/mp-html/mp-html";
export default {
	components: {
		mpHtml,
	},
	data() {
		return {
			detaile: '',
			type: 2, //详情类型：1 普通内容 2 自定义页面内容
			form: {
				page: 1,
				limit: 4,
			},
			contentList: [],
			viewMore: false,
			config: {},
		};
	},

	onLoad: async function(options) {
		uni.showShareMenu({
			withShareTicket: true,
			menus: ['shareAppMessage', 'shareTimeline']
		});
		this.id = options.id;
		await this.getDetail();
		this.getContentList();
		// await this.monitor();
	},
	onShow(){
		this.config =  JSON.parse(req.getStorage('configRes'))
		this.getBrowse();
	},

	onShareAppMessage() {
		return {
			title: this.detaile.title,
			imageUrl: this.detaile.pic,
			path: '/topic/content/content?id=' + this.id +'&isShare=' + true
		};
	},
	onShareTimeline() {
		return {
			title: this.detaile.title,
			imageUrl: this.detaile.pic,
			path: '/topic/content/content?id=' + this.id +'&isShareTimeline=' + true
		};
	},
	methods: {
		monitor() {
			let that = this;
			let system = uni.getSystemInfoSync();
			let query = uni.createSelectorQuery();
			query.select('.viewMore').boundingClientRect(data=>{
				let height = data.height;
				if(height > system.screenHeight) {
					this.viewMore = true
				}
			}).exec();
		},
		viewMores(){
			this.viewMore = true;
		},
		choose: function () {
		  let freshen = false;
		  this.$emit('freshen', {
		    detail: freshen
		  });
		},
		toIndex(){
			uni.switchTab({
				url: '/pages/index/index'
			})
		},
		getDateTimeStamp(dateStr){
		 return util.getDateDiff(Date.parse(dateStr.replace(/-/gi,"/")));
		},
		getDetail() {
			let that = this;
			let apiUrl = '/api/content/detail';
			return new Promise((resolve,reject)=>{
				req.getRequest(apiUrl,{ id: that.id },async res => {
					if(res.productCategory){
						res.productCategory = res.productCategory.split(',')
					}
					that.detaile = res;
					let arr = [];
					if(res.productCategory && res.productCategory.length > 0){
						for (var i = 0; i < res.productCategory.length; i++) {
							await that.getProductList(res.productCategory[i], i).then(res=>{
								arr = arr.concat(res);
								that.productList = arr;
								console.log('相关产品=='+JSON.stringify(arr),arr.length)
							});
						}
					}
					resolve();
				},true);
			})
		},
		getBrowse(){
			let params={
				bindId: this.id,
				type: 2
			}
			req.postRequest('/api/browse', params, data => {});
		},
		getContentList() {
			let form = this.form;
			form.code = req.public.marketCode;
			req.getRequest('/api/content/list',form,res => {
				this.contentList = res;
				for (var i = 0; i < this.contentList.length; i++) {
					if (this.contentList[i].id == this.id){
						this.contentList.splice(i,1);
					}
				}
			});
		},
	},
	filters: {
		/**
		 * 处理富文本里的图片宽度自适应
		 * 1.去掉img标签里的style、width、height属性
		 * 2.img标签添加style属性：max-width:100%;height:auto
		 * 3.修改所有style里的width属性为max-width:100%
		 * 4.去掉<br/>标签
		 * @param html
		 * @returns {void|string|*}
		 */
		formatRichText(html) {
			//控制小程序中图片大小
			let newContent = html.replace(/<img[^>]*>/gi, function(match, capture) {
				match = match.replace(/style="[^"]+"/gi, '').replace(/style='[^']+'/gi, '');
				match = match.replace(/width="[^"]+"/gi, '').replace(/width='[^']+'/gi, '');
				match = match.replace(/height="[^"]+"/gi, '').replace(/height='[^']+'/gi, '');
				return match;
			});
			newContent = newContent.replace(/style="[^"]+"/gi, function(match, capture) {
				match = match.replace(/width:[^;]+;/gi, 'max-width:100%;').replace(/width:[^;]+;/gi, 'max-width:100%;');
				return match;
			});
			// newContent = newContent.replace(/<br[^>]*\/>/gi, '');
			newContent = newContent.replace(/<br[^>]*\/>/gi, '<p style="margin: 10px 0;"></p>');
			newContent = newContent.replace(/<br[^>]*\>/gi, '<p style="margin: 10px 0;"></p>');
			newContent = newContent.replace(/font-size:[^;]+;?/g,'');
			newContent = newContent.replace(/\<img/gi, '<img style="max-width:100%;height:auto;display:inline-block;margin:12rpx auto;"');
			return newContent;
		}
	}
};
</script>
<style>
@import './content.css';
</style>
